Subject: Re: [PATCH] doc: explain the use of color.pager

From: Jonathan Nieder <[email-masked]>
Date: Thu, 20 May 2021 08:05:26 -0700

Hi,

Jeff King wrote:
> On Thu, May 20, 2021 at 03:36:59PM +0900, Junio C Hamano wrote:

>> The original commit and its log message we ended up with did not
>> explain the motivation behind well enough.
>>
>> The motivation from the original thread:
>>
>>       When I use a pager that escapes the escape character or highlights the
>>       content itself the output of git diff without the pager should have
>>       colors but not with the pager.  For example using git diff with a
>>       pathspec is quite short most of the time.  For git diff I have to
>>       enable paging manually and run git diff | $PAGER usually but git log
>>       uses the pager automatically and should not use colors with it.
>>
>> can be quoted as a whole, but "the point is to deal with ..." is a
>> succinct summary that is good enough for the purpose of this commit,
>> I would think.
>
> Thanks, I was just preparing a near-identical response.
>
> I do think it's an important principle in general to summarize the
> content of things we link to. It's just that the summary in this case
> was so short that it was easy to look past. :)

I was making a different point: that the summary is so good that the
link is not even needed (or that if you are just trying to cite your
sources, it should be a footnote).  The current proposed commit
message makes the link prominent, which tells the reader that reading
the thread is a good use of their time, when in this example it isn't.

[...]
>   When color mode options (e.g., `color.ui`) are set to `auto`, Git by
>   default will enable color when the output is going to a terminal or to
>   a pager (since the pager itself is outputting to a terminal). This is
>   a problem if your pager doesn't faithfully relay the color codes to
>   the terminal. You can set this boolean to `false` to disable color
>   when output is going to a terminal.

Oh!  FWIW, I like that and don't think it's overkill.

> On Thu, May 20, 2021 at 03:36:59PM +0900, Junio C Hamano wrote:

>> So, in short, I think it would be sufficient to amend the proposed
>> log message with s/deal with/to deal with/ and nothing else.
>
> I'm happy with that.

Yes, the proposed patch is an improvement on the status quo, so I'd
rather that it land as-is than not land at all.  That said, the
resulting text is still confusing.  It can be easy to forget how much
context we're assuming when we read it ourselves; the proposed text
still makes an uninitiated reader go "huh?" in a way that the "When
color mode options" example above does not.

Thanks,
Jonathan